/*****************************************************************************
 * PROJECT: Carnegie Mellon Planetary Rover Project
 *          Task Control Architecture
 *
 * (c) Copyright 1994.  All rights reserved.
 *
 * MODULE: 
 *
 * FILE: 
 *
 * ABSTRACT:
 *
 * $Source: /afs/cs.cmu.edu/project/TCA/Master/tcaV8/test/b1_var.c,v $ 
 * $Revision: 1.5 $
 * $Date: 1995/07/10 16:19:40 $
 * $Author: rich $
 *
 * REVISION HISTORY:
 *
 * $Log: b1_var.c,v $
 * Revision 1.5  1995/07/10  16:19:40  rich
 * Interm save.
 *
 * Revision 1.4  1995/04/07  05:04:48  rich
 * Fixed GNUmakefiles to find the release directory.
 * Moved all system includes into libc.h
 * Fixed problems found by sgi cc compiler.  Many type problems.
 *
 * Revision 1.3  1995/03/30  15:48:58  rich
 * DBMALLOC works.  To use "gmake -k -w DBMALLOC=DBMALLOC install"
 * Changed Boolean -> BOOLEAN for consistency and to avoid conflicts with x11.
 *
 * Revision 1.2  1994/11/02  21:36:25  rich
 * Now works for linux machines (i486).
 * Got afs to work on alpha (and hopefully other vendor OS's)
 * Added generic Makefile and asynchronous sender/receiver.
 * Made libc.h and tcaMatrix.h module includes.
 *
 * Revision 1.1  1994/05/17  23:20:41  rich
 * Added global variable test routines a1_var and b1_var.  Also make some
 * changes so it would compile on an sgi machine.
 *
 *
 *****************************************************************************/

#include "tca/libc.h"

#include "tca.h"

#include "sample.h"

void sampleVarHnd(TCA_REF_PTR Ref, SamplePtr Sample)
{
 
  SampleType sampleVar1;
 
  printf("SampleHnd: Start.\n");
  
  tcaGetVar(SampleVarName, &sampleVar1);
  
  if (Sample) {
    printf("Sample: %s\n", Sample->s);
    
    free(Sample->s);
    free(Sample);
  }
  else {
    printf("Sample: NULL\n");
    
  }
  
  printf("SampleHnd: Done.\n");
}

#if defined(VXWORKS)
b1main(host)
char *host;
#else
void main(void)
#endif
{
  printf("Connect ...\n");

#if defined(VXWORKS)
  tcaConnectModule("Module B", host);
  regInit();
#else
  tcaConnectModule("Module B", tcaServerMachine());
#endif

  tcaWatchVar(SampleVarName,SampleDataForm, sampleVarHnd);
  
  tcaWaitUntilReady();

  tcaModuleListen();

  exit(0);
}
