/*****************************************************************************
 * PROJECT: TCA
 *
 * (c) Copyright Richard Goodwin, 1995. All rights reserved.
 *
 * FILE: stdinDev.h
 *
 * ABSTRACT:
 * 
 * This file provides routines for connecting stdin to the set of device
 * interfaces (see devUtils.{c,h}).
 *
 * ADAPTED FROM XAVIER SOFTWARE TO FACILITATE ADDING I/O TO MODULES.
 *
 * $Source: /afs/cs.cmu.edu/project/TCA/Master/tcaV8/utils/stdinDev.h,v $ 
 * $Revision: 1.3 $
 * $Date: 1995/08/05 23:23:35 $
 * $Author: rich $
 *
 * REVISION HISTORY:
 *
 * $Log: stdinDev.h,v $
 * Revision 1.3  1995/08/05  23:23:35  rich
 * Added functional interface to devUtils.  See the README for details.
 *
 * Revision 1.2  1995/04/04  19:48:23  rich
 * Added sgi support.
 * Changed setAlarm to setTimer.
 * Numerous improvements and bug fixes in devUtils.
 *
 * Revision 1.1  1995/03/30  15:53:33  rich
 * DBMALLOC works.  To use "gmake -k -w DBMALLOC=DBMALLOC install"
 * Added ezx library and the devutils library.
 *
 *
 *****************************************************************************/

#ifndef STDIN_DEV_LOADED
#define STDIN_DEV_LOADED

#include "tca/devUtils.h"

/* Utility routines */

int noinput (void);

void stdin_defaultInputHnd(int fd, long chars_available);

void stdin_connect(DEVICE_OUTPUT_HND stdinHnd);

/* Global variables */

extern DEV_PTR  stdin_device;

#endif
